
require(data.table)
require(ggplot2)

shock <- read.csv("~/Downloads/Shock.csv")

shockDt = data.table(shock)
Shock_loess<- loess(Price ~ Time, data=shock, span=2/3)
loess_pred <- predict(Shock_loess, data.frame(Time = seq(1, 96, 1)))


Resid <- residuals(Shock_loess)

shockDt =cbind(shockDt, data.table(loess_pred), data.table(Resid))
ggplot(melt(shockDt, id.vars="Time"), aes(x=Time, y=value, colour=variable)) + geom_line()

resids = data.table(Resid)
resids[, lag1Resid := shift(Resid, 1)]
ResReg = lm(Resid~lag1Resid, data=resids[-1])

Cook<- cooks.distance(ResReg)
plot(Cook)
