require(data.table)
require(raster)

hurtt = data.table(read.table("/Users/peteralexander/Documents/R_Workspace/UNPLUM/data/halfdeg/hurtt_2000.txt", sep = "", header=TRUE))
hur=rasterFromXYZ(hurtt[, list(Lon, Lat, CROPLAND)], crs = "+proj=longlat +ellps=WGS84 +datum=WGS84 +no_defs")
plot(hur)




yields = data.table(read.table("/Users/peteralexander/Documents/LURG/LPJ/sam-03Nov2016/yield.out.2011-2015", sep = "", header=TRUE))

plot(rasterFromXYZ(yields[, list(Lon, Lat, TeWW1000)], crs = "+proj=longlat +ellps=WGS84 +datum=WGS84 +no_defs"))


r_f_only = rasterFromXYZ(yields[, list(Lon, Lat, TeWW1000)], crs = "+proj=longlat +ellps=WGS84 +datum=WGS84 +no_defs")
r_f_and_I = rasterFromXYZ(yields[, list(Lon, Lat, TeWWi1000)], crs = "+proj=longlat +ellps=WGS84 +datum=WGS84 +no_defs")

r_diff = r_f_only - r_f_and_I
r_diff_plot = r_diff * (r_diff > 0)
names(r_diff_plot) = "Shortfall after irrig"

plot(
	stack(r_f_only, r_f_and_I, r_diff_plot), nr=3
)



yields = data.table(read.table("/Users/peteralexander/Downloads/presentDay_3degGL_runB_MP/output-2016-10-21/yield.out.2011-2015", sep = "", header=TRUE))
rm (ysum)

for (nrate in c('0', '0005', '0050', '0100', '0200', '0500', '1000')) {
	for (crop in c('TeWW', 'TeCo', 'TrRii', 'TeSW')) {
		row = yields[get(paste0(crop, '0'))>0, list(type=crop, fert=as.numeric(nrate), yield=mean(get(paste0(crop, nrate))))]
		
		if (exists('ysum'))
			ysum=rbind(ysum, row)
		else
			ysum=row
	}
}

require(ggplot2)
ggplot(data=ysum, aes(x=fert, y=yield, colour=type) ) + geom_line() + labs(x='N rate (kg/ha)', y='Yield (kg C/m2 ??)')



irrig_new = rasterFromFile('TeCoi1000', "/Users/peteralexander/Documents/LURG/LPJ/Aug2017/LPJG_PLUM_expt1.1_1961-2015_ipsl_irrV6104_b20170728/1966-1970/gsirrigation.out", 0.25)
i_r = rasterFromFile('TeCoi1000', "/Users/peteralexander/Documents/LURG/LPJ/Aug2017/LPJG_PLUM_expt1.1_1961-2015_ipsl_irrV6104_b20170728/1966-1970/gsirrigation.out", 0.25)
plot(i_r, axes=FALSE, box=FALSE)

plot(i_r * hur * area(i_r))
data.table(as.data.frame(hur * area(i_r) * i_r, na.rm=TRUE))[, sum(layer)]/1000000

boundary = raster("/Users/peteralexander/Documents/R_Workspace/UNPLUM/data/halfdeg/country_boundaries.asc")
crs(boundary) <- '+proj=longlat +ellps=WGS84 +datum=WGS84 +no_defs'
boundary=shift(boundary, -0.25, -0.25)

data.table(as.data.frame(hur * area(i_r) * i_r * (boundary==156), na.rm=TRUE))[, sum(layer)]/1000000



water_avail = data.table(read.table("/Users/peteralexander/Documents/R_Workspace/UNPLUM/data/halfdeg/blue_water_available_pseudoCRU_rcp8p5_2004_2013_grid_allhdyro_mm.txt", header=TRUE))
w_r = rasterFromXYZ(water_avail[, list(Lon, Lat, Max_irr_water)], crs = "+proj=longlat +ellps=WGS84 +datum=WGS84 +no_defs")
#w_r = raster("/Users/peteralexander/Downloads/irrig_constraint.asc")

plot(w_r * (boundary==156))
data.table(as.data.frame(area(w_r) * w_r * (boundary==156), na.rm=TRUE))[, sum(layer)]/1000000
cols <- colorRampPalette(c('blue', 'red'))
par(mar=c(0.5,0.5,0.5,1))
plot(w_r, col=cols(10), axes=FALSE, box=FALSE, breaks=c(0,2,5,10,20,50,100,200,500,1000,1900))

#Runoff
runoffNewDt = data.table(read.table("/Users/peteralexander/Documents/LURG/LPJ/Aug2017/LPJG_PLUM_expt1.1_1961-2015_ipsl_irrV7104_b20170728_bothDS_ts_irrWaits_forED_20170822163840/1966-1970/tot_runoff.out", sep = "", header=TRUE))
runoffNew = rasterFromXYZ(runoffNewDt[, list(Lon, Lat, Total)], crs = "+proj=longlat +ellps=WGS84 +datum=WGS84 +no_defs")
plot(crop(runoffNew, extent(20, 50, -10, 35)))


clusterDT = data.table(as.data.frame(fread("~/Downloads/cluster.asc"), na.rm=TRUE, xy=TRUE))
boundaryDt = data.table(as.data.frame(boundary, na.rm=TRUE, xy=TRUE))
areaDT = data.table(as.data.frame(area(boundary), na.rm=TRUE, xy=TRUE))
clusterSum = merge(boundaryDt, merge(clusterDT, areaDT, by=c("x", "y")), by=c("x", "y"))
unique(clusterSum[, list(country_boundaries, cluster)]) # count clusters
clusterSum[, list(totArea=sum(layer)), by=list(country_boundaries, cluster)][order(totArea)]