require(data.table)
require(raster)

#data_dir_root = "~/Documents/R_Workspace/UNPLUM/data"
data_dir_root = "C:\\Users\\rhenry2\\workspace\\PLUM_src\\plumv2\\plumv2\\data"

createMapForCountries = function(countries, outputFileName) {
	country_codes = fread(file.path(data_dir_root, "country_codes4.csv"), header=TRUE)
	boundary = raster(file.path(data_dir_root, "halfdeg", "country_boundaries.asc"))
	crs(boundary) <- '+proj=longlat +ellps=WGS84 +datum=WGS84 +no_defs'
	
#	b2 = boundary %in% country_codes[Country %in% countries, numCode]
	b2 = boundary %in% country_codes[Region %in% countries, numCode]
	writeRaster(b2, filename=file.path(data_dir_root, "halfdeg", "yieldshockmaps", outputFileName), format='ascii', bylayer=TRUE, overwrite=TRUE)
}

ga = createMapForCountries(c("Latin America & Caribbean"), "Latin America & Caribbean.asc")


#year,mapFilename,crop,shockFactor
climateShockProbs = fread(file.path("C:\\Users\\rhenry2\\workspace\\PLUM_src\\plumv2\\plumv2\\data","climateShockProbabilities.csv"))
scenarioTable = fread(file.path("C:\\Users\\rhenry2\\workspace\\PLUM_src\\plumv2\\plumv2\\data\\sims\\cyberauto.csv"))
climateMaps = basename(list.files(path = "C:\\Users\\rhenry2\\workspace\\PLUM_src\\plumv2\\plumv2\\data\\halfdeg\\yieldshockmaps", full.names = TRUE, recursive = TRUE))



shocksHappen = data.table(SSP_Scenario = scenario[,SSP_SCENARIO], Scenario = scenario[,Scenario], Year = seq(2010,2100,1), 
		climate =as.logical(rbinom(91,size=1,prob = climateShockProbs[rcp == scenario[,RCP],climate])))

tab = NULL
for(year in shocksHappen[,Year]){
		if(shocksHappen[Year == year, climate]){

			mapFilename = sample(climateMaps, 1)
			shockFactor = runif(1,0.1,0.5)
			tab = rbind(tab, cbind(year,mapFilename,crop='maize',shockFactor))
			tab = rbind(tab, cbind(year,mapFilename,crop='rice',shockFactor))
			tab = rbind(tab, cbind(year,mapFilename,crop='cereal',shockFactor))
			}		
		
}


for(i in 1:nrow(scenarioTable)){
#first if column exists
	if("SHOCKS_POSSIBLE" %in% colnames(scenarioTable)){
		if(scenarioTable[i,SHOCKS_POSSIBLE]){
			print(paste("Shocks possible in ",scenarioTable[i,Ensemble],scenarioTable[i,Scenario]))
			createShockFile(scenario = scenarioTable[i])
		}
	}
}