
processedOilCrops = c("Rape and Mustard Oil", "Rape and Mustard Cake", "Soyabean Oil", 
			"Soyabean Cake", "Sunflowerseed Oil", "Sunflowerseed Cake", "Palmkernel Oil")

getItemGroupMapping = function () {
	faoItemGroupMapping = fread(file.path(fao_data_dir, "nutritionItemGroups.csv"))
	setnames(faoItemGroupMapping, gsub(' ', '', (names(faoItemGroupMapping))))  
	faoItemGroupMapping[, Item := gsub(',', '', (Item))]
	
	itemGroupMapping = data.table(
			plumCropItem = c(rep("Monogastrics",3), rep("Ruminants",5),
					rep("WheatBarleyOats",3), rep("MaizeMilletSorghum", 3), "Rice (Paddy Equivalent)"),
			Item=c("Eggs", "Poultry Meat", "Pigmeat", "Milk - Excluding Butter", "Bovine Meat", "Mutton & Goat Meat", "Meat Other", "Animal fats",
					"Wheat and products", "Barley and products", "Oats", "Maize and products", "Millet and products", "Sorghum and products", "Rice (Paddy Equivalent)"),	
			fcr=c(2.3, 3.3, 6.4, 0.7, 25, 15, 15, 9.5, rep(NA, 7)))
	
	itemGroupMapping = rbind(itemGroupMapping, faoItemGroupMapping[plumCropItem %in% c("Oilcrops", "Pulses", "Starchy Roots"), list(plumCropItem, Item, fcr=NA)])

	itemGroupMapping = rbind(itemGroupMapping, data.table(plumCropItem = rep("Oilcrops",length(processedOilCrops)), Item=processedOilCrops, fcr=NA))
	setkey(itemGroupMapping, plumCropItem)
	
	itemGroupMapping
}

itemMapping = getItemGroupMapping()

com_bal_orig = readCommoditiyBalance(FALSE)
com_bal = handleProcessedOilcrops(com_bal_orig, "Oilcrops", processedOilCrops)



#Check for missing items in mapping
itemMapping[!Item %in% unique(com_bal[Year ==2010, Item])]

# only zero weight items
itemMapping[!Item %in% unique(nutritionWeights[weight >0]$Item)]

# This weighting is a feed usage weight.  If we want a weight for a nutrient will have to 
# calculate the nutrient amount for each FAO item as a percentage to the sum of all items 
# for the PLUM type, i.e. the same idea but not using FCR but nutrient content instead.
nutritionDt = merge(com_bal[, list(Country, Year, Item, foodAdj=food)], itemMapping, by='Item')
nutritionDt[!is.na(fcr), foodAdj := list(foodAdj * fcr)]

nutritionWeights = nutritionDt[Year == 2010, list(Item, weight=foodAdj/sum(foodAdj)), by=list(Country, Year, plumCropItem)]

output_dir_root = "/Users/peteralexander/Documents/R_Workspace/UNPLUM/data"
write.table(itemMapping[Item %in% unique(nutritionWeights[weight >0]$Item), list(plumCropItem, Item)], file.path(output_dir_root, "nutritionItemGroups.csv"), sep=",", row.names=FALSE, quote=FALSE)
write.table(nutritionWeights, file.path(output_dir_root, "nutritionItemWeights.csv"), sep=",", row.names=FALSE, quote=FALSE)


