# Checks...
checks = function() {
	country_con_prod[, list(c_m=sum(con_change_area_m), c_c=sum(con_change_area_c), y_m=sum(y_change_area_m ), y_c=sum(y_change_area_c), p_m=sum(pop_change_area_m ), 
					p_c=sum(pop_change_area_c),sum(meat_a),sum(base_meat_a) ), by=Year]
	
	country_con_prod1961[Year == 1996, list(sum(con_change_area_c+ pop_change_area_c+ y_change_area_c)/35, sum(food_nm_a-base_food_nm_a)/35)]
	country_con_prod1961[Year == 1996 & (food_nm_a-base_food_nm_a) > 0, list(sum(food_nm_a-base_food_nm_a)/35)]
	
	country_con_prod1961[Year == 1996 & abs(con_change_area_c+ pop_change_area_c+ y_change_area_c-food_nm_a+base_food_nm_a)>0.4]
	
	setkey(country_con_prod1961,Country)
	dt1 = country_con_prod1961[Year == 1996][country_con_prod1961[Year==1961]][,list(Country, food_nm_a-food_nm_a.1)]
	dt2 = country_con_prod1961[Year == 1996,  list(Country, food_nm_a-base_food_nm_a)]
	dt1[dt2][is.na(V2)]
	
	
	country_con_prod1961[Year == 1996, list(sum(con_change_area_m+con_change_area_c+y_change_area_m +y_change_area_c+pop_change_area_m +pop_change_area_c)/35), by=Year]
	
	
	country_data[Year %in% c(1961, 2011), list(sum(arable), sum(perm_crops), sum(agri)), by=Year]
	a= country_data[Year %in% c(1961, 2011), list(sum(arable), sum(perm_crops), sum(perm_pasture+temp_pasture), sum(agri)), by=Year]
	c(diff(a$V1), diff(a$V2), diff(a$V3), diff(a$V4))
	
	# increases in consumption stats
	country_data[com_bal][!is.na(food ) & Item %in% c("Meat + (Total)", "Pulses + (Total)", "Cereals - Excluding Beer + (Total)") & Year %in% c(1961, 2011), list(sum(food)/1000000, sum(food)/sum(population)), by=list(Year, Item)]
	
	others = con_prod_c[other > 1 & Year ==2011, list(supply=sum(supply)/1000000,other=sum(other)/1000000, prod=sum(prod)/1000000, other_area=sum(other_area)), by=list(mItem ,Year)][other > 1][order(other)]
	others[,percent_other:=other/supply*100]
	others
	
	con_map = consump[Year==2011,list(supply=sum(supply)/1000000,feed=sum(feed)/1000000, food=sum(food)/1000000, waste=sum(waste)/1000000, stockvar=sum(stockvar)/1000000,
					processing=sum(processing)/1000000, seed=sum(seed)/1000000,other=sum(other)/1000000), by=mItem]
	prod_map = prod_c[Year==2011,list(area=sum(area)/1000000, prod=sum(prod)/1000000), by=mItem]
	
	setkey(con_map, mItem)
	setkey(prod_map, mItem)
	
	dt = con_map[prod_map, list(supply=supply, con=feed+food+waste+processing+other-stockvar, prod)]
	dt[!is.na(con), lost_percent:=(prod-supply)/prod*100]
	dt[!is.na(con), lost:=prod-supply]
	
	dt[is.na(con) & (prod > 1)]
	dt[!is.na(prod) & supply > 0.1]
	dt[!is.na(prod) & supply > 1 & lost<0, list(prod=sum(prod), supply=sum(supply), lost=sum(lost))]
	
	prod_map[con_map][is.na(prod) & food > 1, list(mItem, supply)][order(supply)]
	
	dt = country_data[, list(population =sum(population)), by=Year]
	dt[,pop_annual:=c(0, diff(population))]
	dt[,pop_rate:=pop_annual/population*100]
}


drawAllocByTypeSubTypeTreemaps = function(dt, title="", h=6.6, writeToFile=TRUE) {
	print(h)
	dt = copy(dt)
	dt[Type=="Vegetal crops", ColourV:=1]
	dt[Type=="Waste", ColourV:=2]
	dt[Type=="Bioenergy", ColourV:=3]
	dt[Type=="Animal products" & SubType == "Feed", ColourV:=4]
	dt[Type=="Animal products" & SubType == "Pasture", ColourV:=5]
	
	dt[Type=="Animal products",SubType:=sprintf("%s (%0.f Mha)", SubType,sum(Value)), by=list(Type,Pos_neg)]
	dt[,Type:=sprintf("%s (%0.f Mha)", Type,sum(Value)), by=list(Type,Pos_neg)]
	if (title == "1996") {
		dt[Type %like% "Animal products" & SubType %like% "Feed", c('Type', 'SubType') := list(sprintf("Animal feed (%0.f Mha)", Value), "")]
		dt[Type %like% "Animal products" & SubType %like% "Pasture", c('Type', 'SubType') := list(sprintf("Pasture (%0.f Mha)", Value), "")]
	}
	
	dt_p = dt[Pos_neg == "Positive"]
	dt_n = dt[Pos_neg == "Negative"]
	
	w=5.5
	titleHeight=0.4
	
	
	if(writeToFile) pdf(width=w, height=h+titleHeight, file = paste0("~/Documents/Future Earth/Treemaps/alloc_t_st_pos_", title, ".pdf"))
	
	treemap(dt_p, index=c("Type", "SubType"), vSize ="Value", vColor="ColourV",
			title=sprintf("Increasing land allocation (%0.f Mha)", dt_p[,sum(Value)]), fontsize.title = 18, #fontcolor.labels=c("white", "black"),
			lowerbound.cex.labels=0.6, type="manual", palette=c("#800026", "#fc4e2a", "#54278f", "#fe9929", "#fec44f"), range=c(1,5),  position.legend="none",
			bg.labels=0, align.labels=list(c("left", "top"), c("center", "center")), fontsize.labels=c(16,10), algorithm="pivotSize")
	if(writeToFile) dev.off()
	
	if (length(dt_n) > 0) {
		print(h*dt_n[,sum(Value)]/dt_p[,sum(Value)]+titleHeight)
		if(writeToFile) pdf(width=w*dt_n[,sum(Value)]/dt_p[,sum(Value)]+titleHeight, height=h, file = paste0("~/Documents/Future Earth/Treemaps/alloc_t_st_neg_", title, ".pdf"))
		
		treemap(dt_n, index=c("Type", "SubType"), vSize ="Value", vColor="ColourV",
				title=sprintf("Reducing land allocation (%0.f Mha)", dt_n[,sum(Value)]), fontsize.title = 18, #fontcolor.labels=c("white", "black"),
				lowerbound.cex.labels=0.6, type="manual", palette=c("#800026", "#005a32", "#fc4e2a", "#78c679", "#78c679"), range=c(1,5), position.legend="none",
				bg.labels=0, align.labels=list(c("left", "top"), c("center", "center")), fontsize.labels=c(16,10), algorithm="pivotSize")
		
		if(writeToFile) dev.off()
	}
}

dt_1961=getAllocationAsRows(country_con_prod, 1961, 2011)
dt_1996=getAllocationAsRows(country_con_prod, 1996, 2011)

h = 6.6

# Country and Type
dt_1961_ct = dt_1961[!is.na(Value),list(Value=sum(Value)), by=list(Country, Type)]
dt_1961_ct = assignPosNeg(dt_1961_ct)
dt_1996_ct = dt_1996[!is.na(Value),list(Value=sum(Value)), by=list(Country, Type)]
dt_1996_ct = assignPosNeg(dt_1996_ct)

drawAllocByTypeCountryTreemaps(dt_1961_ct, 1961, h)
drawAllocByTypeCountryTreemaps(dt_1996_ct, 1996, h*dt_1996_ct[Pos_neg == "Positive",sum(Value)]/dt_1961_ct[Pos_neg == "Positive",sum(Value)])

# Type and subtype
dt_1961_tts = dt_1961[!is.na(Value),list(Value=sum(Value)), by=list(Type, SubType)]
dt_1961_tts = assignPosNeg(dt_1961_tts)
dt_1996_tts = dt_1996[!is.na(Value),list(Value=sum(Value)), by=list(Type, SubType)]
dt_1996_tts = assignPosNeg(dt_1996_tts)

drawAllocByTypeSubTypeTreemaps(dt_1961_tts, 1961)
drawAllocByTypeSubTypeTreemaps(dt_1996_tts, 1996, h*dt_1996_tts[Pos_neg == "Positive",sum(Value)]/dt_1961_tts[Pos_neg == "Positive",sum(Value)])

# by driver and country	
drawByDriverCountryTreemaps = function(dt, title, h=6.6, writeToFile=TRUE) {
	print(h)
	w=5.5
	titleHeight=0.4
	
	by_driver_country = dt[,list(Value=sum(Value)), by=list(Country, Driver, Pos_neg)] # this is needed because of missing rows (e.g. veg row with no meat row)
	by_driver_country[Driver=="Diet", ColourV:=1]
	by_driver_country[Driver=="Yield", ColourV:=2]
	by_driver_country[Driver=="Population", ColourV:=3]
	by_driver_country[Driver=="Bioenergy", ColourV:=4]
	
	by_driver_country[,Driver:=sprintf("%s (%0.f Mha)", Driver,sum(Value)), by=list(Driver,Pos_neg)]
	
	by_driver_country_p = by_driver_country[Pos_neg == "Positive"]
	by_driver_country_n = by_driver_country[Pos_neg == "Negative"]
	
	if(writeToFile) pdf(width=w, height=h+titleHeight, file = paste0("~/Documents/Future Earth/Treemaps/country_p", title, ".pdf"))
	treemap(by_driver_country_p, index=c("Driver", "Country"), vSize ="Value", vColor="ColourV",
			title=sprintf("Increasing land use allocation (%0.f Mha)", by_driver_country_p[,sum(Value)]), fontsize.title = 18,
			lowerbound.cex.labels=0.6, type="manual", palette=c("#800026", "#fc4e2a", "#feb24c", "#54278f"), range=c(1,4), position.legend="none",
			bg.labels=0, align.labels=list(c("left", "top"), c("center", "center")), fontsize.labels=c(16,10), algorithm="squarified")
	if(writeToFile) dev.off()
	
	if(writeToFile) pdf(width=w, height=h*by_driver_country_n[,sum(Value)]/by_driver_country_p[,sum(Value)]+titleHeight, file = paste0("~/Documents/Future Earth/Treemaps/country_n", title, ".pdf"))
	treemap(by_driver_country_n, index=c("Driver", "Country"), vSize ="Value", vColor="ColourV",
			title=sprintf("Decreasing land use allocation (%0.f Mha)", by_driver_country_n[,sum(Value)]), fontsize.title = 18,
			lowerbound.cex.labels=0.6, type="manual", palette=c("#005a32", "#78c679", "#f7fcb9", "#02818a"), range=c(1,4), position.legend="none",
			bg.labels=0, align.labels=list(c("left", "top"), c("center", "center")), fontsize.labels=c(16,10), algorithm="squarified")
	if(writeToFile) dev.off()
}

dt_1961=getDriverDataAsRows(country_con_prod1961)
dt_1961 = assignPosNeg(dt_1961)
dt_1996=getDriverDataAsRows(country_con_prod1996)
dt_1996 = assignPosNeg(dt_1996)

h = 6.6
drawByDriverCountryTreemaps(dt_1961, 1961, h)
drawByDriverCountryTreemaps(dt_1996, 1996, h*dt_1996[Pos_neg == "Positive",sum(Value)]/dt_1961[Pos_neg == "Positive",sum(Value)])
